/**
   An interface for a line of cars.
   A car object could be a string or an instance of another class such as Car.
   @author Frank M. Carrano
   @author Timothy M. Henry
   @version 5.0
*/
public interface CarLineInterface<T>
{
  /** Adds a car to the back of this line.
      @param aCar  The car object to be added. */
  public void add(T aCar);
  
  /** Removes and returns the car at the front of this line.
      @return  The car at the front of the line.
      @throws  NoSuchElementException if the line is empty before the operation. */
  public T remove();
  
  /** Retrieves the car at the front of this line.
      @return  The car at the front of the line.
      @throws  NoSuchElementException if the line is empty. */
  public T getFront();
  
  /** Detects whether this line is empty.
      @return  True if the line is empty, or false otherwise. */
  public boolean isEmpty();
  
  /** Removes all cars from this line. */
  public void clear();
} // end CarLineInterface
