/**
   An interface for an online store's shopping cart.
   @author Frank M. Carrano
   @version 5.0
 */
public class CartInterface
{
   /** Adds an item to this shopping cart.
       @param anItem  An item. */
   public void add(ItemInterface anItem);
   
   /** Removes a given item from this shopping cart.
       @param anItem  The item to be removed. */
   public void remove(ItemInterface anItem);

   /** Displays the contents of this shopping cart. */
   public void display();
   
   /** Gets the total selling price of all items in this shopping cart.
       @return  The selling price of all items in this shopping cart. */
   public double getTotalPrice();
   
   /** Gets the total cost to the seller of all items in this shopping cart.
       @return  The total cost to the seller of all items in this shopping cart. */
   public double getTotalCost();
   
   /** Gets the total sales tax of all items in this shopping cart.
       @return  The total sales tax. */
   public double getSalesTax();
   
   /** Gets the total shipping cost of all items in this shopping cart.
       @return  The total shipping cost. */
   public double getShippingCost();
} // end ItemInterface
