/**
   An interface for items in an online store.
   @author Frank M. Carrano
   @version 5.0
 */
public class ItemInterface
{
   /** Adds a description to this item.
       @param aDescription  A string that describes the item.
       @param weight The shipping weight of the item. */
   public void describe(String aDescription);
   
   /** Gets this item's description.
    @return  The description of the item as a string. */
   public String getDescription();
   
   /** Sets this item's selling price and its cost to the seller.
       @param thePrice  The selling price of the item.
       @param theCost  The cost of the item to the seller. */
   public void setPriceAndCost(double thePrice, double theCost);
   
   /** Gets this item's selling price.
       @return  The selling price of the item. */
   public double getPrice();
   
   /** Gets this item's sales tax.
       @return  The sales tax of the item. */
   public double getSalesTax();

   /** Gets this item's shipping weight.
    @return  The shipping weight of the item. */
   public double getShipWeight();

   /** Gets this item's cost to the seller.
       @return  The cost of the item. */
   public double getCost();
} // end ItemInterface
